                ORG &100
; *****************************************************************************
; * Tritone v2 Player (with equal channel volumes)
; *
; * By Shiru (shiru@mail.ru) 03'11
; *
; * Three channels of tone, per-pattern tempo
; * One channel of interrupting drums
; * Feel free to do whatever you want with the code, it is PD
; *
; * Produced by Beepola v1.08.01
; ******************************************************************************

beep_on equ 11
beep_off equ 12
beep_xor equ beep_on xor beep_off
beep_port equ &f8

OP_NOP:         EQU   $00                 ; NOP opcode  (used for CHECK_KEMPSTON)
OP_SCF:         EQU   $37                 ; SCF opcode  (used in CHECK_KEMPSTON)
OP_ORC:         EQU   $b1                 ; OR C opcode (used in CHECK_KEMPSTON)

di

ld a,4			;; disconnect fdc interrupt
out (&f8),a
ld a,5			;; set terminal count
out (&f8),a
ld a,6			;; clear terminal count
out (&f8),a
ld a,10			;; turn off disc motor
out (&f8),a	
                LD    HL,MUSICDATA
                CALL  TRI_PLAY
                RET

TRI_PLAY:
                DI
                LD    (NEXT_POS_POS + 1),HL
                LD    C,16
                PUSH  IY
                EXX
                PUSH  HL
                LD    (PREV_SP+1),SP
                XOR   A
                LD    H,A
                LD    L,H
                LD    (CNT0 + 1),HL
                LD    (CNT1 + 1),HL
                LD    (CNT2 + 1),HL
                LD    (DUTY0 + 1),A
                LD    (DUTY1 + 1),A
                LD    (DUTY2 + 1),A
                LD    (SKIP_DRUM),A
               ;; input check removed.
                JP    NEXT_POS

NEXT_ROW:
NEXT_ROW_POS:   LD    HL,0
                LD    A,(HL)
                INC   HL
                CP    2
                JR    C,CH0
                CP    128
                JR    C,DRUM_SOUND
                CP    255
                JP    Z,NEXT_POS
CH0:
                LD    D,1
                CP    D
                JR    Z,CH1
                OR    A
                JR    NZ,CH0_NOTE
                LD    B,A
                LD    C,A
                JR    CH0_SET
CH0_NOTE:       LD    E,A
                AND   $0F
                LD    B,A
                LD    C,(HL)
                INC   HL
                LD    A,E
                AND   $F0
CH0_SET:        LD    (DUTY0 + 1),A
                LD    (CNT0 + 1),BC
CH1:
                LD    A,(HL)
                INC   HL
                CP    D
                JR    Z,CH2
                OR    A
                JR    NZ,CH1_NOTE
                LD    B,A
                LD    C,A
                JR    CH1_SET
CH1_NOTE:       LD    E,A
                AND   $0F
                LD    B,A
                LD    C,(HL)
                INC   HL
                LD    A,E
                AND   $F0
CH1_SET:        LD    (DUTY1 + 1),A
                LD    (CNT1 + 1),BC
CH2:
                LD    A,(HL)
                INC   HL
                CP    D
                JR    Z,SKIP
                OR    A
                JR    NZ,CH2_NOTE
                LD    B,A
                LD    C,A
                JR    CH2_SET
CH2_NOTE:       LD    E,A
                AND   $0F
                LD    B,A
                LD    C,(HL)
                INC   HL
                LD    A,E
                AND   $F0
CH2_SET:        LD    (DUTY2 + 1),A
                LD    (CNT2 + 1),BC
SKIP:
                LD    (NEXT_ROW_POS + 1),HL
SKIP_DRUM:      SCF
                JP    NC,PLAY_ROW
                LD    A,OP_NOP
                LD    (SKIP_DRUM),A
                LD    HL,(TEMPO+1)
                LD    DE,65386                 ; DE = -150 
                ADD   HL,DE
                EX    DE,HL
                JR    C,DRM1
                LD    DE,257
DRM1:           LD    A,D
                OR    A
                JR    NZ,DRM2
                INC   D
DRM2:           LD    A,E
                OR    A
                JR    NZ,DRM3
                INC   E
DRM3:           JR    DRUM

DRUM_SOUND:     LD    (NEXT_ROW_POS + 1),HL
                ADD   A,A
                LD    IXL,A
                LD    IXH,0
                LD    BC,DRUM_SETTINGS - 4
                ADD   IX,BC
                CP    28                       ; 14 * 2
                LD    A,OP_SCF
                LD    (SKIP_DRUM),A
                JR    NC,DRUM_NOISE
DRUM_TONE:      LD    BC,2
                LD    A,B
                LD    DE,$01 + (beep_xor * 256) 
                LD    L,(IX+0)
DRUM_TONE_L0:   BIT   0,B
                JR    Z,DRUM_TONE_L1
                DEC   E
                JR    NZ,DRUM_TONE_L1
                LD    E,L
                EX    AF,AF'
                LD    A,L
                ADD   A,(IX + 1)
                LD    L,A
                EX    AF,AF'
                XOR   D
DRUM_TONE_L1:   OUT   (beep_port),A
                DJNZ  DRUM_TONE_L0
                DEC   C
                JP    NZ,DRUM_TONE_L0
                JP    NEXT_ROW
DRUM_NOISE:     LD    B,0
                LD    H,B
                LD    L,H
                 LD    DE,$01 + (beep_xor * 256) 
DRUM_NOISE_L0:  LD    A,(HL)
                AND   D
                OUT   (beep_port),A
                AND   (IX+0)
                DEC   E
                OUT   (beep_port),A
                JR    NZ,DRUM_NOISE_L1
                LD    E,(IX+1)
                INC   HL
DRUM_NOISE_L1:  DJNZ  DRUM_NOISE_L0
                JP    NEXT_ROW

NEXT_POS:
NEXT_POS_POS:   LD    HL,0
NEXT_POS_READ:  LD    E,(HL)
                INC   HL
                LD    D,(HL)
                INC   HL
                LD    A,D
                OR    E
                JR    Z,ORDER_LOOP
                LD    (NEXT_POS_POS+1),HL
                EX    DE,HL
                LD    C,(HL)
                INC   HL
                LD    B,(HL)
                INC   HL
                LD    (NEXT_ROW_POS+1),HL
                LD    (TEMPO+1),BC
                JP    NEXT_ROW

ORDER_LOOP:     LD    E,(HL)
                INC   HL
                LD    D,(HL)
                EX    DE,HL
                JR    NEXT_POS_READ

PLAY_ROW:
TEMPO:          LD    DE,0
DRUM:
CNT0:           LD    BC,0
PREV_HL         LD    HL,0
                EXX
CNT1:           LD    DE,0
CNT2:           LD    SP,0
                EXX

SOUND_LOOP:
                ADD   HL,BC            ; 11 Ts
                LD    A,H              ;  4 Ts
                EXX                    ;  4 Ts
DUTY0:          CP    128              ;  7 Ts
                SBC   A,A              ;  4 Ts
                AND   C                ;  4 Ts			;; makes it &10 or not
                ADD   IX,DE            ; 15 Ts
                OUT   (beep_port),A          ; 11 Ts
                LD    A,IXH            ;  8 Ts
DUTY1:          CP    128              ;  7 Ts
                SBC   A,A              ;  4 Ts
                AND   C                ;  4 Ts
                OUT   (beep_port),A          ; 11 Ts
                ADD   HL,SP            ; 11 Ts
                LD    A,H              ;  4 Ts
DUTY2:          CP    128              ;  7 Ts
                SBC   A,A              ;  4 Ts
                AND   C                ;  4 Ts
                EXX                    ;  4 Ts
                DEC   E                ;  4 Ts
                OUT   (beep_port),A          ; 11 Ts
                JP    NZ,SOUND_LOOP    ; 10 Ts  = 153
                DEC   D                ;  4 Ts
                JP    NZ,SOUND_LOOP    ; 10 Ts
                ld a,beep_off			;;;XOR   A
                OUT   (beep_port),A
                LD    (PREV_HL + 1),HL

;; input check removed. slightly timing difference
				jp NEXT_ROW
				
STOP_PLAYER:
PREV_SP:        LD    SP,0
                ;;POP   HL
                ;;EXX
                ;;POP   IY
				
				
				ld a,3			;; connect fdc interrupt to int
				out (&f8),a
				
				ld a,beep_off
				out (beep_port),a
                EI
                RET

DRUM_SETTINGS:
                DEFB  $01,$01     ; 1: Tone, Highest
                DEFB  $01,$02
                DEFB  $01,$04
                DEFB  $01,$08
                DEFB  $01,$20
                DEFB  $20,$04
                DEFB  $40,$04
                DEFB  $40,$08     ; 8: Lowest
                DEFB  $04,$80     ; 9: Special
                DEFB  $08,$80
                DEFB  $10,$80
                DEFB  $10,$02
                DEFB  $20,$02
                DEFB  $40,$02
                DEFB  $16,$01     ; 15: Noise, Highest
                DEFB  $16,$02
                DEFB  $16,$04
                DEFB  $16,$08
                DEFB  $16,$10
                DEFB  $00,$01
                DEFB  $00,$02
                DEFB  $00,$04
                DEFB  $00,$08
                DEFB  $00,$10     ; 24: Last drum

; ************************************************************************
; * Song data...
; ************************************************************************
BORDER_CLR:          EQU $0

; *** DATA ***
MUSICDATA:

; *** Song layout ***
                      DEFW      PAT0
                      DEFW      PAT1
                      DEFW      PAT2
                      DEFW      PAT3
                      DEFW      PAT0
                      DEFW      PAT1
                      DEFW      PAT4
LOOPSTART:            DEFW      PAT5
                      DEFW      PAT5
                      DEFW      PAT6
                      DEFW      PAT7
                      DEFW      PAT6
                      DEFW      PAT8
                      DEFW      PAT9
                      DEFW      PAT10
                      DEFW      PAT9
                      DEFW      PAT11
                      DEFW      PAT12
                      DEFW      PAT13
                      DEFW      PAT12
                      DEFW      PAT14
                      DEFW      PAT15
                      DEFW      PAT16
                      DEFW      $0000
                      DEFW      LOOPSTART

; *** Patterns ***
PAT0:
                DEFW  1236     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB      $81,$F4,$80,$FA,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$81,$4D,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT1:
                DEFW  1236     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB      $81,$F4,$81,$76,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$81,$4D,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$81,$76,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$81,$F4,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$82,$31,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT2:
                DEFW  1236     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$BD,$82,$52,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$D8,$82,$76,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT3:
                DEFW  3078     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $02,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $02,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $02,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT4:
                DEFW  1236     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$F4,$01    ,$01
                DEFB      $82,$31,$01    ,$01
                DEFB      $81,$08,$82,$C3,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$18,$82,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$82,$31,$82,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$82,$31,$82,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $02,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $02,$82,$31,$82,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $02,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$3B,$82,$76,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$F4,$82,$9B,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT5:
                DEFW  3078     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB      $81,$4D,$00    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $80,$FA,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$4D,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$8D,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$76,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT6:
                DEFW  3078     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB      $81,$4D,$81,$F4,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$82,$9B,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $80,$FA,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$4D,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$81,$F4,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$A4,$83,$49,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$82,$ED,$01
                DEFB      $81,$BD,$82,$9B,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$82,$31,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$A4,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$76,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $80,$DE,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT7:
                DEFW  3078     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB      $80,$FA,$82,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$82,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$18,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$82,$9B,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$3B,$82,$76,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$82,$9B,$01
                DEFB      $80,$FA,$82,$76,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$82,$31,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$4D,$81,$F4,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$81,$A4,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$76,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$A4,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$81,$A4,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$4D,$81,$BD,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$81,$D8,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT8:
                DEFW  3078     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB      $80,$FA,$82,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$82,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$18,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$82,$9B,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$3B,$82,$76,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$81,$F4,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $80,$FA,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$82,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$4D,$82,$9B,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $80,$FA,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$4D,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT9:
                DEFW  3078     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB  $03,$81,$4D,$81,$F4,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$82,$9B,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$80,$FA,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$81,$4D,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$81,$F4,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$81,$A4,$83,$49,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$82,$ED,$01
                DEFB  $03,$81,$BD,$82,$9B,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$82,$31,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$81,$A4,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$81,$76,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$80,$DE,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT10:
                DEFW  3078     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB  $03,$80,$FA,$82,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$82,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$81,$18,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$82,$9B,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$81,$3B,$82,$76,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$82,$9B,$01
                DEFB  $03,$80,$FA,$82,$76,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$82,$31,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$81,$4D,$81,$F4,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$81,$A4,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$81,$76,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$81,$A4,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$81,$A4,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$81,$4D,$81,$BD,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$81,$D8,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT11:
                DEFW  3078     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB  $03,$80,$FA,$82,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$82,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$81,$18,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$82,$9B,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$81,$3B,$82,$76,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$81,$F4,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$80,$FA,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$82,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$81,$4D,$82,$9B,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$80,$FA,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$81,$4D,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT12:
                DEFW  3078     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB  $03,$81,$A4,$81,$F4,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$81,$A4,$81,$F4,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $02,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$BD,$82,$31,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$A4,$81,$F4,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$81,$F4,$82,$9B,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$81,$BD,$82,$ED,$01
                DEFB  $03,$81,$A4,$83,$E8,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$81,$A4,$83,$E8,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $02,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $82,$31,$84,$63,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $82,$31,$83,$E8,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$81,$F4,$83,$49,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$81,$F4,$82,$9B,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT13:
                DEFW  3078     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB  $03,$81,$BD,$82,$31,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$81,$BD,$82,$31,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $02,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$A4,$81,$F4,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$BD,$82,$31,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$81,$BD,$82,$31,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$81,$76,$82,$ED,$01
                DEFB  $03,$81,$A4,$83,$E8,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$81,$A4,$83,$E8,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $02,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$BD,$84,$63,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$BD,$83,$E8,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$81,$76,$83,$49,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$81,$A4,$82,$9B,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT14:
                DEFW  3078     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB  $03,$82,$31,$81,$BD,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$82,$31,$82,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$82,$31,$82,$9B,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$81,$F4,$82,$76,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$81,$BD,$81,$F4,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$81,$F4,$82,$76,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$81,$F4,$82,$9B,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT15:
                DEFW  3078     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB      $81,$4D,$82,$9B,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$BD,$83,$7B,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$F4,$83,$E8,$01
                DEFB      $82,$31,$82,$9B,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$F4,$82,$76,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$BD,$82,$31,$01
                DEFB      $81,$A4,$81,$F4,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$F4,$82,$76,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$BD,$82,$31,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$81,$4D,$81,$BD,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT16:
                DEFW  3078     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB      $81,$4D,$82,$9B,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$BD,$83,$7B,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$F4,$83,$E8,$01
                DEFB      $82,$31,$82,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$82,$31,$82,$9B,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $02,$82,$31,$82,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $02,$82,$31,$82,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$82,$76,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $02,$81,$F4,$82,$9B,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

