                ORG &100
;;BORDER_COL:     EQU  $0

;; WORKS!

; *****************************************************************************
; * Phaser1 Engine, With Synthesised Drums Samples
; *
; * Original code by Shiru - http://shiru.untergrund.net/
; * Modified by Chris Cowley
; *
; * Produced by Beepola v1.08.01
; ******************************************************************************
 
 
beep_on equ 11
beep_off equ 12
beep_xor equ beep_on xor beep_off
beep_port equ &f8
 
START:  
di

ld a,4			;; disconnect fdc interrupt
out (&f8),a
ld a,5			;; set terminal count
out (&f8),a
ld a,6			;; clear terminal count
out (&f8),a
ld a,10			;; turn off disc motor
out (&f8),a	

             LD    HL,MUSICDATA         ;  <- Pointer to Music Data. Change
                                        ;     this to play a different song
             LD   A,(HL)                         ; Get the loop start pointer
             LD   (PATTERN_LOOP_BEGIN),A
             INC  HL
             LD   A,(HL)                         ; Get the song end pointer
             LD   (PATTERN_LOOP_END),A
             INC  HL
             LD   E,(HL)
             INC  HL
             LD   D,(HL)
             INC  HL
             LD   (INSTRUM_TBL),HL
             LD   (CURRENT_INST),HL
             ADD  HL,DE
             LD   (PATTERN_ADDR),HL
             XOR  A
             LD   (PATTERN_PTR),A                ; Set the pattern pointer to zero
             LD   H,A
             LD   L,A
             LD   (NOTE_PTR),HL                  ; Set the note offset (within this pattern) to 0

PLAYER:
             DI
             PUSH IY
             LD   A,beep_off
             LD   H,$00
             LD   L,A
             LD   (CNT_1A),HL
             LD   (CNT_1B),HL
             LD   (DIV_1A),HL
             LD   (DIV_1B),HL
             LD   (CNT_2),HL
             LD   (DIV_2),HL
             LD   (OUT_1),A
             LD   (OUT_2),A
             JR   MAIN_LOOP

; ********************************************************************************************************
; * NEXT_PATTERN
; *
; * Select the next pattern in sequence (and handle looping if we've reached PATTERN_LOOP_END
; * Execution falls through to PLAYNOTE to play the first note from our next pattern
; ********************************************************************************************************
NEXT_PATTERN:
                          LD   A,(PATTERN_PTR)
                          INC  A
                          INC  A
                          DEFB $FE                           ; CP n
PATTERN_LOOP_END:         DEFB 0
                          JR   NZ,NO_PATTERN_LOOP
                          ; Handle Pattern Looping at and of song
                          DEFB $3E                           ; LD A,n
PATTERN_LOOP_BEGIN:       DEFB 0
NO_PATTERN_LOOP:          LD   (PATTERN_PTR),A
                          LD   HL,$0000
                          LD   (NOTE_PTR),HL   ; Start of pattern (NOTE_PTR = 0)

MAIN_LOOP:
             LD   IYL,0                        ; Set channel = 0

READ_LOOP:
             LD   HL,(PATTERN_ADDR)
             LD   A,(PATTERN_PTR)
             LD   E,A
             LD   D,0
             ADD  HL,DE
             LD   E,(HL)
             INC  HL
             LD   D,(HL)                       ; Now DE = Start of Pattern data
             LD   HL,(NOTE_PTR)
             INC  HL                           ; Increment the note pointer and...
             LD   (NOTE_PTR),HL                ; ..store it
             DEC  HL
             ADD  HL,DE                        ; Now HL = address of note data
             LD   A,(HL)
             OR   A
             JR   Z,NEXT_PATTERN               ; select next pattern

             BIT  7,A
             JP   Z,RENDER                     ; Play the currently defined note(S) and drum
             LD   IYH,A
             AND  $3F
             CP   $3C
             JP   NC,OTHER                     ; Other parameters
             ADD  A,A
             LD   B,0
             LD   C,A
             LD   HL,FREQ_TABLE
             ADD  HL,BC
             LD   E,(HL)
             INC  HL
             LD   D,(HL)
             LD   A,IYL                        ; IYL = 0 for channel 1, or = 1 for channel 2
             OR   A
             JR   NZ,SET_NOTE2
             LD   (DIV_1A),DE
             EX   DE,HL

             DEFB $DD,$21                      ; LD IX,nn
CURRENT_INST:
             DEFW $0000

             LD   A,(IX+$00)
             OR   A
             JR   Z,L809B                      ; Original code jumps into byte 2 of the DJNZ (invalid opcode FD)
             LD   B,A
L8098:       ADD  HL,HL
             DJNZ L8098
L809B:       LD   E,(IX+$01)
             LD   D,(IX+$02)
             ADD  HL,DE
             LD   (DIV_1B),HL
             LD   IYL,1                        ; Set channel = 1
             LD   A,IYH
             AND  $40
             JR   Z,READ_LOOP                  ; No phase reset

			 ld a,beep_off
			 ld (OUT_1),a
             ;;LD   HL,OUT_1                     ; Reset phaser
             ;;RES  4,(HL)
             LD   HL,$0000
             LD   (CNT_1A),HL
             LD   H,(IX+$03)
             LD   (CNT_1B),HL
             JR   READ_LOOP

SET_NOTE2:
             LD   (DIV_2),DE
			 ld a,beep_off
			 ld (OUT_2),a
             LD   A,IYH
			 
             ;;LD   HL,OUT_2
             ;;RES  4,(HL)
             LD   HL,$0000
             LD   (CNT_2),HL
             JP   READ_LOOP

SET_STOP:
             LD   HL,$0000
             LD   A,IYL
             OR   A
             JR   NZ,SET_STOP2
             ; Stop channel 1 note
             LD   (DIV_1A),HL
             LD   (DIV_1B),HL
			 ld a,beep_off
			 ld (OUT_1),A
             ;;LD   HL,OUT_1
             ;;RES  4,(HL)
             LD   IYL,1
             JP   READ_LOOP
SET_STOP2:
             ; Stop channel 2 note
             LD   (DIV_2),HL
			 ld a,beep_off
			 ld (OUT_2),A
             ;;LD   HL,OUT_2
             ;;RES  4,(HL)
             JP   READ_LOOP

OTHER:       CP   $3C
             JR   Z,SET_STOP                   ; Stop note
             CP   $3E
             JR   Z,SKIP_CH1                   ; No changes to channel 1
             INC  HL                           ; Instrument change
             LD   L,(HL)
             LD   H,$00
             ADD  HL,HL
             LD   DE,(NOTE_PTR)
             INC  DE
             LD   (NOTE_PTR),DE                ; Increment the note pointer

             DEFB $01                          ; LD BC,nn
INSTRUM_TBL:
             DEFW $0000

             ADD  HL,BC
             LD   (CURRENT_INST),HL
             JP   READ_LOOP

SKIP_CH1:
             LD   IYL,$01
             JP   READ_LOOP

EXIT_PLAYER:
             ;;LD   HL,$2758
             ;;EXX
             ;;POP  IY
             ;;EI
             ;;RET
			JP 0
			
RENDER:
             AND  $7F                          ; L813A
             CP   $76
             JP   NC,DRUMS
             LD   D,A
             EXX
             DEFB $21                          ; LD HL,nn
CNT_1A:      DEFW $0000
             DEFB $DD,$21                      ; LD IX,nn
CNT_1B:      DEFW $0000
             DEFB $01                          ; LD BC,nn
DIV_1A:      DEFW $0000
             DEFB $11                          ; LD DE,nn
DIV_1B:      DEFW $0000
             DEFB $3E                          ; LD A,n
OUT_1:       DEFB $0
             EXX
             EX   AF,AF'
             DEFB $21                          ; LD HL,nn
CNT_2:       DEFW $0000
             DEFB $01                          ; LD BC,nn
DIV_2:       DEFW $0000
             DEFB $3E                          ; LD A,n
OUT_2:       DEFB $00

PLAY_NOTE:
             ; Read keyboard
             LD   E,A
           ;;  XOR  A
           ;;  IN   A,(beep_port)
          ;;   OR   $E0
          ;;   INC  A

PLAYER_WAIT_KEY:
           ;;  JR   NZ,EXIT_PLAYER
             LD   A,E
             LD   E,0

L8168:       EXX
             EX   AF,AF'
             ADD  HL,BC
             OUT  (beep_port),A
             JR   C,L8171
             JR   L8173
L8171:       XOR  beep_xor
L8173:       ADD  IX,DE
             JR   C,L8179
             JR   L817B
L8179:       XOR  beep_xor
L817B:       EX   AF,AF'
             OUT  (beep_port),A
             EXX
             ADD  HL,BC
             JR   C,L8184
             JR   L8186
L8184:       XOR  beep_xor
L8186:       NOP
             JP   L818A

L818A:       EXX
             EX   AF,AF'
             ADD  HL,BC
             OUT  (beep_port),A
             JR   C,L8193
             JR   L8195
L8193:       XOR  beep_xor
L8195:       ADD  IX,DE
             JR   C,L819B
             JR   L819D
L819B:       XOR  beep_xor
L819D:       EX   AF,AF'
             OUT  (beep_port),A
             EXX
             ADD  HL,BC
             JR   C,L81A6
             JR   L81A8
L81A6:       XOR  beep_xor
L81A8:       NOP
             JP   L81AC

L81AC:       EXX
             EX   AF,AF'
             ADD  HL,BC
             OUT  (beep_port),A
             JR   C,L81B5
             JR   L81B7
L81B5:       XOR  beep_xor
L81B7:       ADD  IX,DE
             JR   C,L81BD
             JR   L81BF
L81BD:       XOR  beep_xor
L81BF:       EX   AF,AF'
             OUT  (beep_port),A
             EXX
             ADD  HL,BC
             JR   C,L81C8
             JR   L81CA
L81C8:       XOR  beep_xor
L81CA:       NOP
             JP   L81CE

L81CE:       EXX
             EX   AF,AF'
             ADD  HL,BC
             OUT  (beep_port),A
             JR   C,L81D7
             JR   L81D9
L81D7:       XOR  beep_xor
L81D9:       ADD  IX,DE
             JR   C,L81DF
             JR   L81E1
L81DF:       XOR  beep_xor
L81E1:       EX   AF,AF'
             OUT  (beep_port),A
             EXX
             ADD  HL,BC
             JR   C,L81EA
             JR   L81EC
L81EA:       XOR  beep_xor

L81EC:       DEC  E
             JP   NZ,L8168

             EXX
             EX   AF,AF'
             ADD  HL,BC
             OUT  (beep_port),A
             JR   C,L81F9
             JR   L81FB
L81F9:       XOR  beep_xor
L81FB:       ADD  IX,DE
             JR   C,L8201
             JR   L8203
L8201:       XOR  beep_xor
L8203:       EX   AF,AF'
             OUT  (beep_port),A
             EXX
             ADD  HL,BC
             JR   C,L820C
             JR   L820E
L820C:       XOR  beep_xor

L820E:       DEC  D
             JP   NZ,PLAY_NOTE

             LD   (CNT_2),HL
             LD   (OUT_2),A
             EXX
             EX   AF,AF'
             LD   (CNT_1A),HL
             LD   (CNT_1B),IX
             LD   (OUT_1),A
             JP   MAIN_LOOP

; ************************************************************
; * DRUMS - Synthesised
; ************************************************************
DRUMS:
             ADD  A,A                          ; On entry A=$75+Drum number (i.e. $76 to $7E)
             LD   B,0
             LD   C,A
             LD   HL,DRUM_TABLE - 236
             ADD  HL,BC
             LD   E,(HL)
             INC  HL
             LD   D,(HL)
             EX   DE,HL
             JP   (HL)

DRUM_TONE1:  LD   L,16
             JR   DRUM_TONE
DRUM_TONE2:  LD   L,12
             JR   DRUM_TONE
DRUM_TONE3:  LD   L,8
             JR   DRUM_TONE
DRUM_TONE4:  LD   L,6
             JR   DRUM_TONE
DRUM_TONE5:  LD   L,4
             JR   DRUM_TONE
DRUM_TONE6:  LD   L,2
DRUM_TONE:
             LD   DE,3700		
             LD   BC,$0101
             LD   A,beep_off
DT_LOOP0:    OUT  (beep_port),A
             DEC  B
             JR   NZ,DT_LOOP1
             XOR  beep_xor
             LD   B,C
             EX   AF,AF'
             LD   A,C
             ADD  A,L
             LD   C,A
             EX   AF,AF'
DT_LOOP1:    DEC  E
             JR   NZ,DT_LOOP0
             DEC  D
             JR   NZ,DT_LOOP0
             JP   MAIN_LOOP

DRUM_NOISE1: LD   DE,2480		;; IN ROM AND duration!
			ld hl,L2480
             LD   IXL,1
             JR   DRUM_NOISE
DRUM_NOISE2: LD   DE,1070		;; IN ROM!
			ld hl,L1070
             LD   IXL,10
             JR   DRUM_NOISE
DRUM_NOISE3: LD   DE,365		;; IN ROM!
			ld hl,L365
             LD   IXL,101
DRUM_NOISE:
             ;;LD   H,D
             ;;LD   L,E
             LD   A,beep_off
             LD   C,A
			 ;; 1011
DN_LOOP0:    LD   A,(HL)
			;; for now, need better on PCW
			 AND 1
			 add a,11

;;             AND  16				;; 16 or 0
									;; maps to 11 or 12
 ;;            OR   C
             OUT  (beep_port),A
             LD   B,IXL
DN_LOOP1:    DJNZ DN_LOOP1
             INC  HL
             DEC  E
             JR   NZ,DN_LOOP0
             DEC  D
             JR   NZ,DN_LOOP0
             JP   MAIN_LOOP

PATTERN_ADDR:   DEFW  $0000
PATTERN_PTR:    DEFB  0
NOTE_PTR:       DEFW  $0000

L365:
L1070:
L2480:


; **************************************************************
; * Frequency Table
; **************************************************************
FREQ_TABLE:
             DEFW 178,189,200,212,225,238,252,267,283,300,318,337
             DEFW 357,378,401,425,450,477,505,535,567,601,637,675
             DEFW 715,757,802,850,901,954,1011,1071,1135,1202,1274,1350
             DEFW 1430,1515,1605,1701,1802,1909,2023,2143,2270,2405,2548,2700
             DEFW 2860,3030,3211,3402,3604,3818,4046,4286,4541,4811,5097,5400

; *****************************************************************
; * Synth Drum Lookup Table
; *****************************************************************
DRUM_TABLE:
             DEFW DRUM_TONE1,DRUM_TONE2,DRUM_TONE3,DRUM_TONE4,DRUM_TONE5,DRUM_TONE6
             DEFW DRUM_NOISE1,DRUM_NOISE2,DRUM_NOISE3


MUSICDATA:
             DEFB 0  ; Pattern loop begin * 2
             DEFB 80  ; Song length * 2
             DEFW 40         ; Offset to start of song (length of instrument table)
             DEFB 3      ; Multiple
             DEFW 3      ; Detune
             DEFB 4      ; Phase
             DEFB 1      ; Multiple
             DEFW 1      ; Detune
             DEFB 0      ; Phase
             DEFB 3      ; Multiple
             DEFW 2      ; Detune
             DEFB 0      ; Phase
             DEFB 2      ; Multiple
             DEFW 3      ; Detune
             DEFB 2      ; Phase
             DEFB 1      ; Multiple
             DEFW 0      ; Detune
             DEFB 3      ; Phase
             DEFB 4      ; Multiple
             DEFW 1      ; Detune
             DEFB 4      ; Phase
             DEFB 1      ; Multiple
             DEFW 1      ; Detune
             DEFB 5      ; Phase
             DEFB 3      ; Multiple
             DEFW 3      ; Detune
             DEFB 0      ; Phase
             DEFB 2      ; Multiple
             DEFW 1      ; Detune
             DEFB 2      ; Phase
             DEFB 1      ; Multiple
             DEFW 3      ; Detune
             DEFB 4      ; Phase

PATTERNDATA:        DEFW      PAT0
                    DEFW      PAT0
                    DEFW      PAT0
                    DEFW      PAT0
                    DEFW      PAT1
                    DEFW      PAT2
                    DEFW      PAT3
                    DEFW      PAT4
                    DEFW      PAT5
                    DEFW      PAT6
                    DEFW      PAT7
                    DEFW      PAT8
                    DEFW      PAT9
                    DEFW      PAT10
                    DEFW      PAT11
                    DEFW      PAT12
                    DEFW      PAT11
                    DEFW      PAT12
                    DEFW      PAT1
                    DEFW      PAT2
                    DEFW      PAT4
                    DEFW      PAT2
                    DEFW      PAT1
                    DEFW      PAT2
                    DEFW      PAT15
                    DEFW      PAT16
                    DEFW      PAT5
                    DEFW      PAT7
                    DEFW      PAT8
                    DEFW      PAT9
                    DEFW      PAT17
                    DEFW      PAT11
                    DEFW      PAT12
                    DEFW      PAT11
                    DEFW      PAT13
                    DEFW      PAT0
                    DEFW      PAT0
                    DEFW      PAT0
                    DEFW      PAT0
                    DEFW      PAT14

; *** Pattern data - $00 marks the end of a pattern ***
PAT0:
         DEFB $BD,2
         DEFB 152
         DEFB 140
         DEFB 118
     DEFB 2
         DEFB $BD,4
         DEFB 152
         DEFB 140
         DEFB 124
     DEFB 2
         DEFB $BD,6
         DEFB 164
         DEFB 152
     DEFB 3
         DEFB $BD,8
         DEFB 152
         DEFB 140
         DEFB 125
     DEFB 2
         DEFB $BD,10
         DEFB 152
         DEFB 140
         DEFB 118
     DEFB 2
         DEFB $BD,12
         DEFB 164
         DEFB 152
     DEFB 3
         DEFB $BD,14
         DEFB 152
         DEFB 140
         DEFB 118
     DEFB 2
         DEFB $BD,16
         DEFB 152
         DEFB 140
         DEFB 124
     DEFB 2
         DEFB $BD,2
         DEFB 164
         DEFB 152
         DEFB 126
     DEFB 2
         DEFB $BD,4
         DEFB 152
         DEFB 140
         DEFB 118
     DEFB 2
         DEFB $BD,6
         DEFB 152
         DEFB 140
         DEFB 124
     DEFB 2
         DEFB $BD,8
         DEFB 164
         DEFB 152
         DEFB 118
     DEFB 2
         DEFB $BD,10
         DEFB 152
         DEFB 140
         DEFB 125
     DEFB 2
         DEFB $BD,12
         DEFB 152
         DEFB 140
     DEFB 3
         DEFB $BD,14
         DEFB 164
         DEFB 152
         DEFB 124
     DEFB 2
         DEFB $BD,16
         DEFB 152
         DEFB 140
     DEFB 3
         DEFB $00
PAT1:
         DEFB $BD,0
         DEFB 168
         DEFB 137
         DEFB 118
     DEFB 2
         DEFB $BD,4
         DEFB 149
         DEFB 137
         DEFB 124
     DEFB 2
         DEFB $BD,0
         DEFB 169
         DEFB 149
     DEFB 3
         DEFB $BD,8
         DEFB 149
         DEFB 137
         DEFB 125
     DEFB 2
         DEFB $BD,0
         DEFB 168
         DEFB 137
         DEFB 118
     DEFB 2
         DEFB $BD,12
         DEFB 161
         DEFB 149
     DEFB 3
         DEFB $BD,14
         DEFB 149
         DEFB 137
         DEFB 118
     DEFB 2
         DEFB $BD,16
         DEFB 149
         DEFB 137
         DEFB 124
     DEFB 2
         DEFB $BD,0
         DEFB 173
         DEFB 149
         DEFB 126
     DEFB 2
         DEFB $BD,4
         DEFB 149
         DEFB 137
         DEFB 118
     DEFB 2
         DEFB $BD,6
         DEFB 149
         DEFB 137
         DEFB 124
     DEFB 2
         DEFB $BD,8
         DEFB 161
         DEFB 149
         DEFB 118
     DEFB 2
         DEFB $BD,10
         DEFB 149
         DEFB 137
         DEFB 125
     DEFB 2
         DEFB $BD,12
         DEFB 149
         DEFB 137
     DEFB 3
         DEFB $BD,0
         DEFB 164
         DEFB 149
         DEFB 124
     DEFB 2
         DEFB $BD,16
         DEFB 149
         DEFB 137
     DEFB 3
         DEFB $00
PAT2:
         DEFB $BD,2
         DEFB 149
         DEFB 137
         DEFB 118
     DEFB 2
         DEFB $BD,4
         DEFB 149
         DEFB 137
         DEFB 124
     DEFB 2
         DEFB $BD,6
         DEFB 161
         DEFB 149
     DEFB 3
         DEFB $BD,8
         DEFB 149
         DEFB 137
         DEFB 125
     DEFB 2
         DEFB $BD,10
         DEFB 149
         DEFB 137
         DEFB 118
     DEFB 2
         DEFB $BD,12
         DEFB 161
         DEFB 149
     DEFB 3
         DEFB $BD,14
         DEFB 149
         DEFB 137
         DEFB 118
     DEFB 2
         DEFB $BD,16
         DEFB 149
         DEFB 137
         DEFB 124
     DEFB 2
         DEFB $BD,2
         DEFB 161
         DEFB 149
         DEFB 126
     DEFB 2
         DEFB $BD,4
         DEFB 149
         DEFB 137
         DEFB 118
     DEFB 2
         DEFB $BD,6
         DEFB 149
         DEFB 137
         DEFB 124
     DEFB 2
         DEFB $BD,8
         DEFB 161
         DEFB 149
         DEFB 118
     DEFB 2
         DEFB $BD,10
         DEFB 149
         DEFB 137
         DEFB 125
     DEFB 2
         DEFB $BD,12
         DEFB 149
         DEFB 137
     DEFB 3
         DEFB $BD,14
         DEFB 161
         DEFB 149
         DEFB 124
     DEFB 2
         DEFB $BD,16
         DEFB 149
         DEFB 137
     DEFB 3
         DEFB $00
PAT3:
         DEFB $BD,0
         DEFB 168
         DEFB 137
         DEFB 118
     DEFB 2
         DEFB $BD,4
         DEFB 149
         DEFB 137
         DEFB 124
     DEFB 2
         DEFB $BD,0
         DEFB 169
         DEFB 137
     DEFB 3
         DEFB $BD,8
         DEFB 149
         DEFB 149
         DEFB 125
     DEFB 2
         DEFB $BD,0
         DEFB 168
         DEFB 137
         DEFB 118
     DEFB 2
         DEFB $BD,12
         DEFB 161
         DEFB 137
     DEFB 3
         DEFB $BD,14
         DEFB 149
         DEFB 149
         DEFB 118
     DEFB 2
         DEFB $BD,16
         DEFB 149
         DEFB 137
         DEFB 124
     DEFB 2
         DEFB $BD,0
         DEFB 169
         DEFB 137
         DEFB 126
     DEFB 2
         DEFB $BD,4
         DEFB 149
         DEFB 149
         DEFB 118
     DEFB 2
         DEFB $BD,6
         DEFB 149
         DEFB 137
         DEFB 124
     DEFB 2
         DEFB $BD,8
         DEFB 161
         DEFB 137
         DEFB 118
     DEFB 2
         DEFB $BD,10
         DEFB 149
         DEFB 149
         DEFB 125
     DEFB 2
         DEFB $BD,12
         DEFB 149
         DEFB 137
     DEFB 3
         DEFB $BD,0
         DEFB 168
         DEFB 137
         DEFB 124
     DEFB 2
         DEFB $BD,16
         DEFB 149
         DEFB 149
     DEFB 3
         DEFB $00
PAT4:
         DEFB $BD,0
         DEFB 166
         DEFB 137
         DEFB 118
     DEFB 2
         DEFB $BD,0
         DEFB 168
         DEFB 137
         DEFB 124
     DEFB 2
         DEFB $BD,0
         DEFB 169
         DEFB 149
     DEFB 3
         DEFB $BD,0
         DEFB 168
         DEFB 137
         DEFB 125
     DEFB 2
         DEFB $BD,10
         DEFB 149
         DEFB 137
         DEFB 118
     DEFB 2
         DEFB $BD,12
         DEFB 161
         DEFB 137
     DEFB 3
         DEFB $BD,14
         DEFB 149
         DEFB 149
         DEFB 118
     DEFB 2
         DEFB $BD,16
         DEFB 149
         DEFB 137
         DEFB 124
     DEFB 2
         DEFB $BD,2
         DEFB 161
         DEFB 137
         DEFB 126
     DEFB 2
         DEFB $BD,4
         DEFB 149
         DEFB 149
         DEFB 118
     DEFB 2
         DEFB $BD,6
         DEFB 149
         DEFB 137
         DEFB 124
     DEFB 2
         DEFB $BD,8
         DEFB 161
         DEFB 137
         DEFB 118
     DEFB 2
         DEFB $BD,10
         DEFB 149
         DEFB 149
         DEFB 125
     DEFB 2
         DEFB $BD,12
         DEFB 149
         DEFB 137
     DEFB 3
         DEFB $BD,14
         DEFB 161
         DEFB 137
         DEFB 124
     DEFB 2
         DEFB $BD,16
         DEFB 149
         DEFB 149
     DEFB 3
         DEFB $00
PAT5:
         DEFB $BD,18
         DEFB 176
         DEFB 140
         DEFB 118
     DEFB 2
         DEFB $BD,2
         DEFB 152
         DEFB 140
         DEFB 124
     DEFB 2
         DEFB $BD,18
         DEFB 178
         DEFB 152
     DEFB 3
         DEFB $BD,4
         DEFB 152
         DEFB 140
         DEFB 125
     DEFB 2
         DEFB $BD,18
         DEFB 179
         DEFB 140
         DEFB 118
     DEFB 2
         DEFB $BD,6
         DEFB 152
         DEFB 152
     DEFB 3
         DEFB $BD,18
         DEFB 181
         DEFB 140
         DEFB 118
     DEFB 2
         DEFB $BD,8
         DEFB 152
         DEFB 140
         DEFB 124
     DEFB 2
         DEFB $BD,18
         DEFB 176
         DEFB 152
         DEFB 126
     DEFB 2
         DEFB $BD,10
         DEFB 152
         DEFB 140
         DEFB 118
     DEFB 2
         DEFB $BD,18
         DEFB 178
         DEFB 140
         DEFB 124
     DEFB 2
         DEFB $BD,12
         DEFB 152
         DEFB 152
         DEFB 118
     DEFB 2
         DEFB $BD,18
         DEFB 179
         DEFB 140
         DEFB 125
     DEFB 2
         DEFB $BD,14
         DEFB 152
         DEFB 140
     DEFB 3
         DEFB $BD,18
         DEFB 181
         DEFB 152
         DEFB 124
     DEFB 2
         DEFB $BD,16
         DEFB 188
         DEFB 140
     DEFB 3
         DEFB $00
PAT6:
         DEFB $BD,18
         DEFB 183
         DEFB 140
         DEFB 118
     DEFB 2
         DEFB $BD,2
         DEFB 152
         DEFB 140
         DEFB 124
     DEFB 2
         DEFB $BD,18
         DEFB 181
         DEFB 152
     DEFB 3
         DEFB $BD,4
         DEFB 152
         DEFB 140
         DEFB 125
     DEFB 2
         DEFB $BD,18
         DEFB 179
         DEFB 140
         DEFB 118
     DEFB 2
         DEFB $BD,6
         DEFB 152
         DEFB 152
     DEFB 3
         DEFB $BD,18
         DEFB 178
         DEFB 140
         DEFB 118
     DEFB 2
         DEFB $BD,8
         DEFB 152
         DEFB 140
         DEFB 124
     DEFB 2
         DEFB $BD,18
         DEFB 183
         DEFB 152
         DEFB 126
     DEFB 2
         DEFB $BD,10
         DEFB 152
         DEFB 140
         DEFB 118
     DEFB 2
         DEFB $BD,18
         DEFB 181
         DEFB 140
         DEFB 124
     DEFB 2
         DEFB $BD,12
         DEFB 152
         DEFB 152
         DEFB 118
     DEFB 2
         DEFB $BD,18
         DEFB 179
         DEFB 140
         DEFB 125
     DEFB 2
         DEFB $BD,14
         DEFB 152
         DEFB 140
     DEFB 3
         DEFB $BD,18
         DEFB 178
         DEFB 152
         DEFB 124
     DEFB 2
         DEFB $BD,16
         DEFB 152
         DEFB 140
     DEFB 3
         DEFB $00
PAT7:
         DEFB $BD,2
         DEFB 152
         DEFB 176
         DEFB 118
     DEFB 2
         DEFB $BD,4
         DEFB 152
         DEFB 179
         DEFB 124
     DEFB 2
         DEFB $BD,6
         DEFB 164
         DEFB 178
     DEFB 3
         DEFB $BD,8
         DEFB 152
         DEFB 179
         DEFB 125
     DEFB 2
         DEFB $BD,10
         DEFB 152
         DEFB 181
         DEFB 118
     DEFB 2
         DEFB $BD,12
         DEFB 164
         DEFB 179
     DEFB 3
         DEFB $BD,14
         DEFB 152
         DEFB 178
         DEFB 118
     DEFB 2
         DEFB $BD,16
         DEFB 152
         DEFB 179
         DEFB 124
     DEFB 2
         DEFB $BD,2
         DEFB 164
         DEFB 176
         DEFB 126
     DEFB 2
         DEFB $BD,4
         DEFB 152
         DEFB 179
         DEFB 118
     DEFB 2
         DEFB $BD,6
         DEFB 152
         DEFB 181
         DEFB 124
     DEFB 2
         DEFB $BD,8
         DEFB 164
         DEFB 179
         DEFB 118
     DEFB 2
         DEFB $BD,10
         DEFB 152
         DEFB 183
         DEFB 125
     DEFB 2
         DEFB $BD,12
         DEFB 152
         DEFB 181
     DEFB 3
         DEFB $BD,14
         DEFB 164
         DEFB 179
         DEFB 124
     DEFB 2
         DEFB $BD,16
         DEFB 152
         DEFB 178
     DEFB 3
         DEFB $00
PAT8:
         DEFB $BD,2
         DEFB 152
         DEFB 183
         DEFB 118
     DEFB 2
         DEFB $BD,4
         DEFB 152
         DEFB 181
         DEFB 124
     DEFB 2
         DEFB $BD,6
         DEFB 164
         DEFB 179
     DEFB 3
         DEFB $BD,8
         DEFB 152
         DEFB 178
         DEFB 125
     DEFB 2
         DEFB $BD,10
         DEFB 152
         DEFB 181
         DEFB 118
     DEFB 2
         DEFB $BD,12
         DEFB 164
         DEFB 179
     DEFB 3
         DEFB $BD,14
         DEFB 152
         DEFB 178
         DEFB 118
     DEFB 2
         DEFB $BD,16
         DEFB 152
         DEFB 176
         DEFB 124
     DEFB 2
         DEFB $BD,2
         DEFB 164
         DEFB 179
         DEFB 126
     DEFB 2
         DEFB $BD,4
         DEFB 152
         DEFB 178
         DEFB 118
     DEFB 2
         DEFB $BD,6
         DEFB 152
         DEFB 176
         DEFB 124
     DEFB 2
         DEFB $BD,8
         DEFB 164
         DEFB 174
         DEFB 118
     DEFB 2
         DEFB $BD,10
         DEFB 152
         DEFB 173
         DEFB 125
     DEFB 2
         DEFB $BD,12
         DEFB 152
         DEFB 171
     DEFB 3
         DEFB $BD,14
         DEFB 164
         DEFB 169
         DEFB 124
     DEFB 2
         DEFB $BD,16
         DEFB 152
         DEFB 167
     DEFB 3
         DEFB $00
PAT9:
         DEFB $BD,0
         DEFB 168
         DEFB 185
         DEFB 118
     DEFB 2
         DEFB $BD,4
         DEFB 149
         DEFB 124
     DEFB 2
         DEFB $BD,0
         DEFB 169
         DEFB 188
     DEFB 3
         DEFB $BD,8
         DEFB 149
         DEFB 183
         DEFB 125
     DEFB 2
         DEFB $BD,0
         DEFB 168
         DEFB 188
         DEFB 118
     DEFB 2
         DEFB $BD,12
         DEFB 161
         DEFB 181
     DEFB 3
         DEFB $BD,14
         DEFB 149
         DEFB 188
         DEFB 118
     DEFB 2
         DEFB $BD,16
         DEFB 149
         DEFB 180
         DEFB 124
     DEFB 2
         DEFB $BD,0
         DEFB 169
         DEFB 126
     DEFB 2
         DEFB $BD,4
         DEFB 149
         DEFB 188
         DEFB 118
     DEFB 2
         DEFB $BD,6
         DEFB 149
         DEFB 124
     DEFB 2
         DEFB $BD,8
         DEFB 161
         DEFB 118
     DEFB 2
         DEFB $BD,10
         DEFB 149
         DEFB 181
         DEFB 125
     DEFB 2
         DEFB $BD,12
         DEFB 149
         DEFB 180
     DEFB 3
         DEFB $BD,0
         DEFB 168
         DEFB 178
         DEFB 124
     DEFB 2
         DEFB $BD,16
         DEFB 149
         DEFB 183
     DEFB 3
         DEFB $00
PAT10:
         DEFB $BD,0
         DEFB 168
         DEFB 185
         DEFB 118
     DEFB 2
         DEFB $BD,4
         DEFB 149
         DEFB 181
         DEFB 124
     DEFB 2
         DEFB $BD,0
         DEFB 169
     DEFB 3
         DEFB $BD,8
         DEFB 149
         DEFB 180
         DEFB 125
     DEFB 2
         DEFB $BD,0
         DEFB 168
         DEFB 118
     DEFB 2
         DEFB $BD,12
         DEFB 161
         DEFB 188
     DEFB 3
         DEFB $BD,14
         DEFB 149
         DEFB 118
     DEFB 2
         DEFB $BD,16
         DEFB 149
         DEFB 124
     DEFB 2
         DEFB $BD,0
         DEFB 169
         DEFB 126
     DEFB 2
         DEFB $BD,4
         DEFB 149
         DEFB 118
     DEFB 2
         DEFB $BD,6
         DEFB 149
         DEFB 124
     DEFB 2
         DEFB $BD,8
         DEFB 161
         DEFB 118
     DEFB 2
         DEFB $BD,10
         DEFB 149
         DEFB 125
     DEFB 2
         DEFB $BD,12
         DEFB 149
     DEFB 3
         DEFB $BD,0
         DEFB 168
         DEFB 176
         DEFB 124
     DEFB 2
         DEFB $BD,16
         DEFB 149
     DEFB 3
         DEFB $00
PAT11:
         DEFB $BD,2
         DEFB 152
         DEFB 179
         DEFB 118
     DEFB 2
         DEFB $BD,4
         DEFB 190
         DEFB 178
         DEFB 124
     DEFB 2
         DEFB $BD,6
         DEFB 167
         DEFB 176
         DEFB 118
     DEFB 2
         DEFB $BD,8
         DEFB 190
         DEFB 188
         DEFB 123
     DEFB 2
         DEFB $BD,10
         DEFB 169
         DEFB 178
         DEFB 124
     DEFB 2
         DEFB $BD,12
         DEFB 190
         DEFB 188
         DEFB 125
     DEFB 2
         DEFB $BD,14
         DEFB 171
         DEFB 174
         DEFB 124
     DEFB 2
         DEFB $BD,16
         DEFB 190
         DEFB 169
         DEFB 125
     DEFB 2
         DEFB $BD,2
         DEFB 174
         DEFB 188
         DEFB 124
     DEFB 2
         DEFB $BD,4
         DEFB 190
         DEFB 164
         DEFB 122
     DEFB 2
         DEFB $BD,6
         DEFB 175
         DEFB 167
         DEFB 124
     DEFB 2
         DEFB $BD,8
         DEFB 190
         DEFB 188
         DEFB 120
     DEFB 2
         DEFB $BD,10
         DEFB 176
         DEFB 176
         DEFB 124
     DEFB 2
         DEFB $BD,12
         DEFB 190
         DEFB 174
         DEFB 125
     DEFB 2
         DEFB $BD,14
         DEFB 178
         DEFB 188
         DEFB 124
     DEFB 2
         DEFB $BD,16
         DEFB 190
         DEFB 169
         DEFB 125
     DEFB 2
         DEFB $00
PAT12:
         DEFB $BD,2
         DEFB 150
         DEFB 177
         DEFB 118
     DEFB 2
         DEFB $BD,4
         DEFB 190
         DEFB 176
         DEFB 124
     DEFB 2
         DEFB $BD,6
         DEFB 165
         DEFB 174
     DEFB 3
         DEFB $BD,8
         DEFB 190
         DEFB 188
         DEFB 125
     DEFB 2
         DEFB $BD,10
         DEFB 167
         DEFB 176
         DEFB 118
     DEFB 2
         DEFB $BD,12
         DEFB 190
         DEFB 188
     DEFB 3
         DEFB $BD,14
         DEFB 169
         DEFB 172
         DEFB 118
     DEFB 2
         DEFB $BD,16
         DEFB 190
         DEFB 167
         DEFB 124
     DEFB 2
         DEFB $BD,2
         DEFB 172
         DEFB 188
         DEFB 126
     DEFB 2
         DEFB $BD,4
         DEFB 190
         DEFB 162
         DEFB 118
     DEFB 2
         DEFB $BD,6
         DEFB 173
         DEFB 165
         DEFB 124
     DEFB 2
         DEFB $BD,8
         DEFB 190
         DEFB 188
         DEFB 118
     DEFB 2
         DEFB $BD,10
         DEFB 174
         DEFB 174
         DEFB 125
     DEFB 2
         DEFB $BD,12
         DEFB 190
         DEFB 172
     DEFB 3
         DEFB $BD,14
         DEFB 176
         DEFB 188
         DEFB 124
     DEFB 2
         DEFB $BD,16
         DEFB 190
         DEFB 167
     DEFB 3
         DEFB $00
PAT13:
         DEFB $BD,2
         DEFB 154
         DEFB 181
         DEFB 118
     DEFB 2
         DEFB $BD,4
         DEFB 190
         DEFB 180
         DEFB 124
     DEFB 2
         DEFB $BD,6
         DEFB 169
         DEFB 178
     DEFB 3
         DEFB $BD,8
         DEFB 190
         DEFB 188
         DEFB 125
     DEFB 2
         DEFB $BD,10
         DEFB 171
         DEFB 180
         DEFB 118
     DEFB 2
         DEFB $BD,12
         DEFB 190
         DEFB 188
     DEFB 3
         DEFB $BD,14
         DEFB 173
         DEFB 176
         DEFB 118
     DEFB 2
         DEFB $BD,16
         DEFB 190
         DEFB 171
         DEFB 124
     DEFB 2
         DEFB $BD,2
         DEFB 176
         DEFB 188
         DEFB 126
     DEFB 2
         DEFB $BD,4
         DEFB 190
         DEFB 166
         DEFB 118
     DEFB 2
         DEFB $BD,6
         DEFB 177
         DEFB 169
         DEFB 124
     DEFB 2
         DEFB $BD,8
         DEFB 190
         DEFB 188
         DEFB 118
     DEFB 2
         DEFB $BD,10
         DEFB 178
         DEFB 178
         DEFB 125
     DEFB 2
         DEFB $BD,12
         DEFB 190
         DEFB 176
     DEFB 3
         DEFB $BD,14
         DEFB 180
         DEFB 188
         DEFB 124
     DEFB 2
         DEFB $BD,16
         DEFB 190
         DEFB 171
     DEFB 3
         DEFB $00
PAT14:
         DEFB $BD,2
         DEFB 152
         DEFB 140
         DEFB 118
     DEFB 2
         DEFB 188
         DEFB 119
     DEFB 2
         DEFB 190
         DEFB 188
         DEFB 120
     DEFB 2
         DEFB $BD,2
         DEFB 152
         DEFB 140
         DEFB 121
     DEFB 2
         DEFB 190
         DEFB 122
     DEFB 2
         DEFB 190
         DEFB 188
         DEFB 123
     DEFB 2
         DEFB $BD,4
         DEFB 164
         DEFB 140
         DEFB 124
     DEFB 2
         DEFB $BD,6
         DEFB 190
     DEFB 3
         DEFB $BD,8
         DEFB 190
         DEFB 126
     DEFB 2
         DEFB $BD,10
         DEFB 152
         DEFB 140
         DEFB 126
     DEFB 2
         DEFB $BD,12
         DEFB 190
         DEFB 126
     DEFB 2
         DEFB $BD,14
         DEFB 190
         DEFB 188
         DEFB 126
     DEFB 2
         DEFB $BD,16
         DEFB 190
         DEFB 126
     DEFB 2
         DEFB $BD,18
         DEFB 188
         DEFB 126
     DEFB 8
         DEFB $00
PAT15:
         DEFB $BD,0
         DEFB 164
         DEFB 135
         DEFB 118
     DEFB 2
         DEFB $BD,0
         DEFB 166
         DEFB 135
         DEFB 124
     DEFB 2
         DEFB $BD,0
         DEFB 167
         DEFB 147
     DEFB 3
         DEFB $BD,0
         DEFB 166
         DEFB 135
         DEFB 125
     DEFB 2
         DEFB $BD,10
         DEFB 147
         DEFB 135
         DEFB 118
     DEFB 2
         DEFB $BD,12
         DEFB 159
         DEFB 135
     DEFB 3
         DEFB $BD,14
         DEFB 147
         DEFB 147
         DEFB 118
     DEFB 2
         DEFB $BD,16
         DEFB 147
         DEFB 135
         DEFB 124
     DEFB 2
         DEFB $BD,2
         DEFB 159
         DEFB 135
         DEFB 126
     DEFB 2
         DEFB $BD,4
         DEFB 147
         DEFB 147
         DEFB 118
     DEFB 2
         DEFB $BD,6
         DEFB 147
         DEFB 135
         DEFB 124
     DEFB 2
         DEFB $BD,8
         DEFB 159
         DEFB 135
         DEFB 118
     DEFB 2
         DEFB $BD,10
         DEFB 147
         DEFB 147
         DEFB 125
     DEFB 2
         DEFB $BD,12
         DEFB 147
         DEFB 135
     DEFB 3
         DEFB $BD,14
         DEFB 159
         DEFB 135
         DEFB 124
     DEFB 2
         DEFB $BD,16
         DEFB 147
         DEFB 147
     DEFB 3
         DEFB $00
PAT16:
         DEFB $BD,2
         DEFB 151
         DEFB 139
         DEFB 118
     DEFB 2
         DEFB $BD,4
         DEFB 151
         DEFB 139
         DEFB 124
     DEFB 2
         DEFB $BD,6
         DEFB 163
         DEFB 151
     DEFB 3
         DEFB $BD,8
         DEFB 151
         DEFB 139
         DEFB 125
     DEFB 2
         DEFB $BD,10
         DEFB 151
         DEFB 139
         DEFB 118
     DEFB 2
         DEFB $BD,12
         DEFB 163
         DEFB 151
     DEFB 3
         DEFB $BD,14
         DEFB 151
         DEFB 139
         DEFB 118
     DEFB 2
         DEFB $BD,16
         DEFB 151
         DEFB 139
         DEFB 124
     DEFB 2
         DEFB $BD,2
         DEFB 163
         DEFB 151
         DEFB 126
     DEFB 2
         DEFB $BD,4
         DEFB 151
         DEFB 139
         DEFB 118
     DEFB 2
         DEFB $BD,6
         DEFB 151
         DEFB 139
         DEFB 124
     DEFB 2
         DEFB $BD,8
         DEFB 163
         DEFB 151
         DEFB 118
     DEFB 2
         DEFB $BD,10
         DEFB 151
         DEFB 139
         DEFB 125
     DEFB 2
         DEFB $BD,12
         DEFB 151
         DEFB 139
     DEFB 3
         DEFB $BD,14
         DEFB 163
         DEFB 151
         DEFB 124
     DEFB 2
         DEFB $BD,16
         DEFB 151
         DEFB 139
     DEFB 3
         DEFB $00
PAT17:
         DEFB $BD,0
         DEFB 168
         DEFB 187
         DEFB 118
     DEFB 2
         DEFB $BD,4
         DEFB 149
         DEFB 185
         DEFB 124
     DEFB 2
         DEFB $BD,0
         DEFB 169
     DEFB 3
         DEFB $BD,8
         DEFB 149
         DEFB 180
         DEFB 125
     DEFB 2
         DEFB $BD,0
         DEFB 168
         DEFB 118
     DEFB 2
         DEFB $BD,12
         DEFB 161
         DEFB 188
     DEFB 3
         DEFB $BD,14
         DEFB 149
         DEFB 118
     DEFB 2
         DEFB $BD,16
         DEFB 149
         DEFB 124
     DEFB 2
         DEFB $BD,0
         DEFB 169
         DEFB 126
     DEFB 2
         DEFB $BD,4
         DEFB 149
         DEFB 118
     DEFB 2
         DEFB $BD,6
         DEFB 149
         DEFB 124
     DEFB 2
         DEFB $BD,8
         DEFB 161
         DEFB 118
     DEFB 2
         DEFB $BD,10
         DEFB 149
         DEFB 125
     DEFB 2
         DEFB $BD,12
         DEFB 149
     DEFB 3
         DEFB $BD,0
         DEFB 168
         DEFB 176
         DEFB 124
     DEFB 2
         DEFB $BD,16
         DEFB 149
     DEFB 3
         DEFB $00
